diff --git a/books/bookvol10.4.pamphlet b/books/bookvol10.4.pamphlet
index 3852e20..5f2cc03 100644
--- a/books/bookvol10.4.pamphlet
+++ b/books/bookvol10.4.pamphlet
@@ -120410,9 +120410,11 @@ PatternMatchIntegerNumberSystem(I:IntegerNumberSystem): with
                                          uur.exponent, l,1)) => failed()
        patternMatchRestricted(pr.base, uur.val, l, 1)
      (w := isTimes p) case List(PAT) =>
-       patternMatchSumProd(x, w::List(PAT), l, #1 exquo #2, 1)
+       patternMatchSumProd(x, w::List(PAT), l,
+        (i1:I,i2:I):Union(I,"failed") +-> i1 exquo i2, 1)
      (w := isPlus p) case List(PAT) =>
-      patternMatchSumProd(x,w::List(PAT),l,(#1-#2)::Union(I,"failed"),0)
+      patternMatchSumProd(x,w::List(PAT),l,
+        (i1:I,i2:I):Union(I,"failed") +-> (i1-i2)::Union(I,"failed"),0)
      (uv := isQuotient p) case Record(num:PAT, den:PAT) =>
        uvr := uv::Record(num:PAT, den:PAT)
        (r := retractIfCan(uvr.num)@Union(Integer,"failed")) case Integer
diff --git a/changelog b/changelog
index 33afdb2..cee0e43 100644
--- a/changelog
+++ b/changelog
@@ -1,5 +1,7 @@
-20090609 tpd src/axiom-website/patches.html 20090610.01.tpd.patch
-20090609 tpd books/bookvol10.4 PMFS +-> conversion
+20090610 tpd src/axiom-website/patches.html 20090610.02.tpd.patch
+20090610 tpd books/bookvol10.4 PMINS +-> conversion
+20090610 tpd src/axiom-website/patches.html 20090610.01.tpd.patch
+20090610 tpd books/bookvol10.4 PMFS +-> conversion
 20090609 tpd src/axiom-website/patches.html 20090609.09.tpd.patch
 20090609 tpd books/bookvol10.4 PATTERN1 +-> conversion
 20090609 tpd src/axiom-website/patches.html 20090609.08.tpd.patch
diff --git a/src/axiom-website/patches.html b/src/axiom-website/patches.html
index 2dd40c8..bbb355b 100644
--- a/src/axiom-website/patches.html
+++ b/src/axiom-website/patches.html
@@ -1533,5 +1533,7 @@ bookvol10.4 PARTPERM +-> conversion<br/>
 bookvol10.4 PATTERN1 +-> conversion<br/>
 <a href="patches/20090610.01.tpd.patch">20090610.01.tpd.patch</a>
 bookvol10.4 PMFS +-> conversion<br/>
+<a href="patches/20090610.02.tpd.patch">20090610.02.tpd.patch</a>
+bookvol10.4 PMINS +-> conversion<br/>
  </body>
 </html>
